/*
	Client side JavaScript. 
	All database operations should go through methods.js
*/


if (Meteor.isClient) {

	Session.set('add_game', false);
	Session.set('add_question', false);
	Session.set('play_game', false);
	Session.set('show_friends', false);
	Session.set('invite_player', false);
	Session.set('enteredQuestion', false);
	Session.set('enteredAnswer', false);
	Session.set('currentGameId', null);
	Session.set('hasUpdatedFriends', false);
	Session.set('currentGamePlayers', null);
	Session.set('questionId', null);
	Session.set('questionCompleted', false);
	Session.set('userFacebookId', null);
	Session.set('userArray'), null;
	Session.set('showNextQuestion'), null;

	new_question = false;

	Meteor.subscribe("friends");
	Meteor.subscribe("games");
	Meteor.subscribe("playergames");
	Meteor.subscribe("questions");
	Meteor.subscribe("userquestions");
	Meteor.subscribe("gameusers");




	/*
		Config for Facebook integration.
		Facebook code is in facebook.js
	*/

	Accounts.ui.config({
		passwordSignupFields: "USERNAME_ONLY",
		requestPermissions: {
			facebook: ['public_profile', 'email', 'user_friends']
		}
	});



	/*
		Events for interaction with Facebook
	*/

	Template.facebookfriends.events({
		
		/* // Old version with jQuery
		
		'click #btn-user-data': function(e) {
			Meteor.call('getUserData', function(err, data) {
				$('#userdata').empty();
				userInfo = JSON.parse(JSON.stringify(data, undefined, 4));
				$('#userdata').append('<div class="friendinfo"><img src="http://graph.facebook.com/' + userInfo.id + '/picture?type=square"/>' + '<span class="friendname">' + userInfo.name + '</span></div>');
			});			
		},

		'click #btn-friends-data': function(e) {
			//showFriendList();
		},
		*/


		/*
			Event triggered by clicking friend name.
			Toggle status (player or non-player) for current game and add or remove player accordingly.
		*/

		'click #userlist .friendinfo': function(e,t) {
			if (Session.get('invite_player')) {
				console.log("clicked friend " + this.id + " " + Session.get('currentGameId') + " " + this._id + " " + Meteor.userId());

				var userArray = Session.get('userArray');

				if (userArray == undefined || !(userArray.length > 0)) {
					userArray = [];
				} 
				console.log(this);
				//console.log("friend " + this.id);

				// jQuery-option
				//if ($('#'+e.currentTarget.id).hasClass('selected-friend'))
				
				// JavaScript option
				// Check if user is already selected and if so remove user from array
				if (document.getElementById(e.currentTarget.id).className.indexOf("selected-friend") > -1) {
					for (var i=0; i<userArray.length; i++) {
						if (userArray[i] == this.id) {
							console.log("Removing user " + userArray[i]);
							userArray.splice(i, 1);
							break;
						}
					}
				} else {
					// Friend is now selected, add to friend array
					userArray.push(this.id);
				}

				// Debug
				for (var i=0; i<userArray.length; i++) {
					console.log("Current user in userArray " + userArray[i]);
				}

				Session.set('userArray', userArray);
			}
		},


		/*
			Event triggered for current game when gamemaster has added/managed players from Facebook friend list
		*/

		'click #btn-friends-submit': function(e) {
			Session.set('invite_player', false);
			console.log("Done adding friends");
			console.log("Adding friends to game " + Session.get('userArray'));
			Meteor.call('addFriendsToGame', Session.get('userArray'), Session.get('currentGameId'), function(err, data) {});
			var friendArray = Meteor.apply('findPlayersInGame', [Session.get('currentGameId')], {returnStubValue: true});    		
    		console.log(friendArray);
		}
	});



	/*
		Helper functions for the facebookfriends template
	*/

	Template.facebookfriends.helpers({

		/*
			Initial fetching from Facebook, runs once at startup. (Might be moved to a separate startup/init js-file.)
			Stores friends in database.
			Returns complete friend list.	
		*/

    	friends: function () {
    		// Run once at new session to get updated friend list from Facebook.
    		if (!Session.get('hasUpdatedFriends')) {
				console.log('hasUpdatedFriends');		
	    		Meteor.call('getFriendsData', function(err, friendData) {
		        	Meteor.call('updateFriends', friendData["data"], function(err, data) {});
			    });
			    Session.set('hasUpdatedFriends' , true);
    		}
        	return Friends.find({}, {sort: {name: -1}});
    	},


		show_friends: function() {
			return Session.equals('show_friends', true);
		},
    });




	/*
		Helpers for the listfriends template
	*/

	Template.listfriends.helpers({


		/*
			Checks and returns selected-friend or empty class based on user array for current game.
			Toggles by clicking friend in friend list.
		*/

    	selectedFriend: function() {
    		var returnstring = "";
			var user = GameUsers.findOne({gameId: Session.get('currentGameId'), facebookId: this.id});

			console.log("user " + user);
			if (user != undefined) {
				var completed = Meteor.apply('checkNumberOfCompletedQuestions', [Session.get('currentGameId'), user.owner], {returnStubValue: true});
				var total = Meteor.apply('checkNumberOfQuestions', [Session.get('currentGameId')], {returnStubValue: true});
				completed--;
				if (completed == total) {
					returnstring += "finished-playing ";
				}
			}
    		var userArray = Session.get('userArray');
			if (userArray == undefined || (userArray.length == 0)) {
				userArray = [];
			} else {
				for (var i=0; i<userArray.length; i++) {
					if (userArray[i] == this.id) {
						returnstring += "selected-friend";
					}
				}
			}
    		return returnstring;
    	},


		/*
			Outputs players' progress in the current game
		*/

		progress: function() {
			var progress = "";
			var user = GameUsers.findOne({gameId: Session.get('currentGameId'), facebookId: this.id});
			
			// This should be changed, problems with async call
			/* var progress = Meteor.call('getUserGame', [Session.get('currentGameId'), this.id], function(err, user) {
				console.log("us " + user);
				var completed = Meteor.apply('checkNumberOfCompletedQuestions', [Session.get('currentGameId'), user.owner], {returnStubValue: true});
				var total = Meteor.apply('checkNumberOfQuestions', [Session.get('currentGameId')], {returnStubValue: true});
				completed--;
				var progress = completed + " of " + total + " levels completed";
				console.log(progress);
				return progress;
			});

			return progress;
			*/
			console.log("USER " + user);
			if (user != undefined) {
				var completed = Meteor.apply('checkNumberOfCompletedQuestions', [Session.get('currentGameId'), user.owner], {returnStubValue: true});
				var total = Meteor.apply('checkNumberOfQuestions', [Session.get('currentGameId')], {returnStubValue: true});
				completed--;
				progress = completed + " of " + total + " levels completed";
			}
			return progress;
			//*/
		}

	});


	/*
		Events when adding game.
	*/

	Template.addgame.events({


		/*
			Click on add game button, set session variable and focus on game name input field.
			(Might be a problem with latency for focus here.)
		*/

		'click #btn-add-game': function(e, t) {
			Session.set('add_game', true);
			Tracker.flush();
			focusInputField(t.find("#add-game"));
		},


		/*
			Triggers when user has entered the name of the new game.
		*/

		'keyup #add-game': function(e, t) {
			// Check for Enter/Return and non-empty value of game name
			if ((e.which == 13) && (e.target.value != "")) {
				Meteor.call("addGame", e.target.value, function(err, data){
					var newGameId = data;
					console.log("gameid... " + newGameId);
					Session.set('currentGameId', newGameId);
				});
				Session.set('add_game', false);
			}
		},

		/*
			Click on play game button
		*/

		'click #btn-play-game': function(e, t) {
			Session.set('play_game', true);
			Tracker.flush();
		},

	});




	/*
		Helpers for addgame template
	*/

	Template.addgame.helpers({

		/*
			If true, shows game name input field in addgame template
		*/
		new_game: function() {
			return Session.equals('add_game', true);
		},

		/*
			Return name for use in buttons
		*/
    	username: function () {
    		return getUserName();
    	}

	});


	/*
		Events for adding players to current game.
	*/

	Template.inviteplayer.events({

/*
// Old version
		'click #btn-invite-player': function(e, t) {
			Session.set('invite_player', true);
			console.log("invite player");
			Session.set('currentGameId', this.gameId);
			Session.set('userArray', []);
			//showFriendList();
			Tracker.flush();
		},
*/

		/*
			Triggers when gamemaster will add and manage players for the current game.
		*/

		'click #btn-manage-players': function(e, t) {
			Session.set('invite_player', true);
			Session.set('currentGameId', this.gameId);
			var userArray = Meteor.apply('findPlayersInGame', [this.gameId], {returnStubValue: true});   
			console.log(userArray);
			Session.set('userArray', userArray);

			console.log("gameId in inviteplayer " + this.gameId);
			//console.log("FB ID " + getUserFacebookId());
			//showFriendList();
			Tracker.flush();
		}
	});


	/*
		Helpers for inviteplayer template
	*/

	Template.inviteplayer.helpers({

		/*
			Checks if selected game should show friend list for inviting players.
		*/

		invite_player: function(gameId) {
			return ((Session.get('currentGameId') == gameId) && Session.equals('invite_player', true));
		}
	});


	Template.deletegame.events({
		'click #btn-delete-game': function(e, t) {
			Meteor.call('deleteGame', this.gameId, function(err, data) {});
		}
	});


	Template.addquestion.events({

		'click #btn-add-game-question': function(e, t) {
			var questionId = Random.id();
			Session.set('add_question' + questionId, true); // Should questionId be part of add_question?
			Session.set('questionId', questionId);
			console.log('button questionId ' + questionId + " gameId " + this.gameId);
			Tracker.flush();
//			focusInputField(t.find("#add-game-question"));
		},
/*
		'keyup #add-game-question': function(e, t) {
			// Check for Enter/Return tab
			if ((e.which == 13) || (e.which == 11)) {
				//addGame(e.target.value);
//				Meteor.call("addQuestion", e.target.value, this._id);
				if (Session.get('enteredAnswer')) {
					Meteor.call('addQuestion', e.target.value, Session.get('answerValue'), Session.get('questionId'), Session.get('currentGameId'), "congratulation3", "reward", 138);
					resetQuestionData();
				} else {
					Session.set('enteredQuestion', true);
					//Session.set('questionId', this._id);
					Session.set('questionValue', e.target.value);
					focusInputField(t.find("#add-game-answer"));
				}
			}
		},

		'keyup #add-game-answer': function(e, t) {
			// Check for Enter/Return
			if ((e.which == 13) || (e.which == 11)) {
				//addGame(e.target.value);
				if (Session.get('enteredQuestion')) {
					Meteor.call('addQuestion', Session.get('questionValue'), e.target.value, Session.get('questionId'), Session.get('currentGameId'), "congratulation3", "reward", 138);
					Session.set('answer', null);
					resetQuestionData();
				} else {
					Session.set('enteredAnswer', true);
					Session.set('answerValue', e.target.value);
					focusInputField(t.find("#add-game-question"));
				}
			}
		},

*/
		'submit .new-question': function(e,t) {
			event.preventDefault();

			const target = event.target;

			var question, answer, congratulation, rewards, points;

			var questionId = Session.get('questionId');

			question = target.addgamequestion.value;
			answer = target.addgameanswer.value;
			congratulation = target.addgamecongratulation.value;
			rewards = target.addgamereward.value;
			points = target.addgamepoints.value;

			if (question==undefined) question = "";
			if (answer==undefined) answer = "";
			if (congratulation==undefined) congratulation = "";
			if (rewards==undefined) rewards = "";
			if (points==undefined) points = 0;

			console.log("Adding question " + questionId);
			Meteor.call('addQuestion', this.gameId, questionId, question, answer, congratulation, rewards, points);
			Session.set('add_question' + questionId, false);
			Session.set('questionId', null);
		},

		'click #btn-cancel-add-question': function(e,t) {
			event.preventDefault();
			Session.set('add_question' + Session.get('questionId'), false);
		}
	});

	function resetQuestionData () {
		Session.set('add_question' + Session.get('questionId'), false);
		Session.set('enteredQuestion', false);
		Session.set('enteredAnswer', false);
		Session.set('questionId', null);
		Tracker.flush();
	}


	Template.addquestion.helpers({
		new_question: function() {
//			return Session.equals('add_question' + Session.get('questionId'), true);
		},

		isCurrentQuestion: function(id) {
			//console.log("id " + id  + " currentGameId " + " - " + Session.get('currentGameId'));
			return (Session.equals('add_question' + Session.get('questionId'), true));
			//return true;
		},

    	questions: function () {
    		console.log("gameId question " + this.gameId);

        	return Questions.find({gameId: this.gameId}, {sort: {createdAt: -1}});
    	},

    	totalpoints: function() {
        	var questionlist = Questions.find({gameId: this.gameId}).fetch();

        	var totalpoints = 0;
        	for (var question in questionlist) {
        		totalpoints += +questionlist[question].points;
        	}
        	return totalpoints;
    	}

	});




	Template.question_and_answer.helpers({
		isCurrentQuestion: function(id) {
			console.log("id " + id  + " questionId " + " - " + Session.get('questionId'))
			if (Session.get('questionId') == id) {
				return true;
			}
			return false;
		},

		getAnswer: function(questionId) {
			var answer = AnswerQuestions.findOne({questionId: questionId});
			if (answer!=undefined)  {
				return answer.answer;
			}
			return;
		}
	});



	Template.question_and_answer.events({
		'click .questionitem': function(e,t) {
			Session.set('questionId', this.questionId);
			console.log("Questionitem");
			console.log(this);
		},

		'submit .edit-question': function(e,t) {
			event.preventDefault();
			console.log("EDIT QUESTION");
			const target = event.target;

			var question, answer, congratulation, rewards, points;

			var questionId = Session.get('questionId');

			question = target.addgamequestion.value;
			answer = target.addgameanswer.value;
			congratulation = target.addgamecongratulation.value;
			rewards = target.addgamereward.value;
			points = target.addgamepoints.value;

			if (question==undefined) question = "";
			if (answer==undefined) answer = "";
			if (congratulation==undefined) congratulation = "";
			if (rewards==undefined) rewards = "";
			if (points==undefined) points = 0;

			console.log("Adding question " + questionId);
			Meteor.call('addQuestion', this.gameId, questionId, question, answer, congratulation, rewards, points);
			Session.set('add_question' + questionId, false);
			Session.set('questionId', null);
		},

		'click #btn-delete-question': function(e, t) {
			console.log("DELETE");
			console.log(this.questionId);
			Meteor.call('deleteQuestion', this.questionId, function(err, data) {});
		},

		'click #btn-cancel-edit-question': function(e,t) {
			//e.preventDefault();
			e.stopPropagation();
			console.log("CANCEL " + Session.get('questionId'))
			Session.set('add_question' + Session.get('questionId'), false);
			Session.set('questionId', null);
			console.log("CANCEL " + Session.get('questionId'))
		}

		
	});



	Template.question_no_answer.helpers({
		isQuestionCompleted: function() {
/*			Meteor.call('checkPlayerCompletedQuestion', this.questionId, function(error, completed) {
				Session.set('completed', completed);
			});

			return Session.get('completed');
*/
	  		var question = UserQuestions.findOne({questionId: this.questionId, player: Meteor.userId()});
			if ((question != undefined) && (question.completed)) {
				return true;
			} else {
				console.log("Wrong answer");
			}
			return false;
		},

/*
		showNextQuestion: function() {
			if (!Session.get('stopNextQuestion')) {
	  			var question = UserQuestions.findOne({questionId: this.questionId, player: Meteor.userId()});
				if (question != undefined) {
			 		if (!question.completed) {
						Session.set('stopNextQuestion', true);
						console.log("Returns true for questionId " + this.questionId);
						return true;
					}
				}
			}
			console.log("Returns false for questionId " + this.questionId);
			return true;
		},
*/

		getCongratulation() {

/*			Meteor.call('getAnswerObject', this.questionId, function(error, answer) {
				if (answer != undefined) {
					console.log(answer);
//		  			Session.set('answerObject', answer)
		  		}
			});
*/
			return Meteor.apply('getAnswerObject', [this.questionId], {returnStubValue: true}).congratulation;

//			console.log("res");
//			console.log(result.congratulation);

//*/
//			answerObject = Session.get('answerObject');
//			if (answerObject != undefined) return answerObject.congratulation;
/*
			var meth = Async.wrap(Meteor.call('getAnswerObject', this.questionId, function(error, answer) {
				if (answer != undefined) {
					console.log(answer);
			  	}
			  	return answer;
				})
			);

			return meth();
*/
		},

		getReward() {
			return Meteor.apply('getAnswerObject', [this.questionId], {returnStubValue: true}).reward;
		},

		getPoints() {
			return Meteor.apply('getAnswerObject', [this.questionId], {returnStubValue: true}).points;
		}


	});


	Template.game.helpers({
		getTotalPoints: function() {
			console.log("Total points");
			console.log(this._id);

			return Meteor.apply('getTotalPointsForGame', [this._id], {returnStubValue: true});
		},

		gamehasplayers: function() {
			var userArray = Meteor.apply('findPlayersInGame', [this.gameId], {returnStubValue: true});
			console.log(userArray); 
			if (userArray.length > 0) {
				return true;
			}
			return false;
		},

		gameplayers: function() {
			var userArray = Meteor.apply('findPlayersInGame', [this.gameId], {returnStubValue: true});
        	return Friends.find({
        		id: {"$in" : userArray} 
        	}, {sort: {name: -1}});
		},

		is_current_game: function() {
			if (this.gameId == Session.get('currentGameId')) {
				console.log("is current_game");
				return true;
			} else {
				Session.set('invite_player', false);
				console.log("is NOT current_game");
				return false;
			}
		},

		is_game_master: function() {
			var game = Games.findOne({    	
				gameId: this.gameId,
		    	owner: Meteor.userId()
			}); 
			if (game != undefined) {
				return true;
			} else {
				return false;
			}
		}

	});


	Template.playquestion.events({
		'keyup .play-game-question': function(e, t) {
			if ((e.which == 13) || (e.which == 11)) {
				//console.log(this);
				var correctAnswer = Meteor.apply('checkCorrectAnswer', [this.questionId, e.target.value, Session.get('userFacebookId')], {returnStubValue: true});
				console.log("Correct Answer: " + correctAnswer);
			}
		}
	});


	Template.playquestion.helpers({

		updateUserIds: function() {
//			GameUsers.insert({gameId: this.gameId, facebookId: getUserFacebookId(), player: Meteor.userId(), owner: Meteor.userId()});
			Meteor.apply('insertGameUser', [this.gameId, getUserFacebookId()], {returnStubValue: true});
			console.log("Updated user ids");
		},

		totalPoints: function() {
			var points = Meteor.apply('getTotalPoints', [this.gameId, Meteor.userId()], {returnStubValue: true});
			return points;
		},

		questions: function () {
    		console.log("playquestion_gameId " + this.gameId);
    		var gameId = this.gameId;
    		var quest = Questions.find({gameId: gameId}, {sort: {createdAt: 1}});


    		var correctCounter = 0;
			var comp = Meteor.apply('checkNumberOfCompletedQuestions', [gameId, Meteor.userId()], {returnStubValue: true});
			console.log("COMPLETED " + comp);
			return Questions.find({gameId: gameId}, {sort: {createdAt: 1}, limit: Meteor.apply('checkNumberOfCompletedQuestions', [gameId, Meteor.userId()], {returnStubValue: true})});

/*			var test = 0;
    		quest.forEach(function(question) {
	   			test = Meteor.apply('checkPlayerCompletedQuestion', question.questionId, {returnStubValue: true});
    			console.log(test);
    		});

	    		return quest;
    			/*
    				if (completed) {
    					correctCounter++;
    					console.log("completed");
    				} else {
    					//return Questions.find({gameId: gameId}, {sort: {createdAt: 1}, limit: comp});
    				}
    				console.log("!!!!!!!! " + correctCounter);
    			})
    			console.log("TEST " + test);
    		});
    		*/

			//return Questions.find({gameId: gameId}, {sort: {createdAt: 1}, limit: comp});

/*
    		console.log("CORR " + correctCounter);
    		var questionlist = Questions.find({gameId: this.gameId}, {sort: {createdAt: 1}}, {limit: correctCounter});
    		return questionlist;
    		var test = quest.fetch();
    		return test;
    		var results = [];
    		for (var i = 0; i < completed; i++) {
    			results.push(test[i]);
    		}
    		return results;

    		console.log(quest);
    		return quest;
*/
        }


	});


	Template.body.events({

		// Focus outside game items
		'click .container': function(e,t) {
			if (Session.get('currentGameId') != null) {
				Session.set('currentGameId', null);
			}
		},

		// Set current game when clicking on gameitem
		'click .gameitem': function(e,t) {
			e.stopPropagation();
			if (Session.get('currentGameId' != this.gameId)) {
				console.log("Setting invite_player false");
				Session.set('invite_player', false);
			}
			Session.set('currentGameId', this.gameId);
		}
	});




	Template.body.helpers({
    	games: function () {
        	// User is gamemaster
        	return Meteor.apply('findGameMasterGames', [getUserFacebookId()], {returnStubValue: true});
    	},

    	playergames: function () {
	       	var facebookId = getUserFacebookId();
        	var games = Meteor.apply('findPlayerGames', [facebookId], {returnStubValue: true});
        	return games;

    	},

		has_game_as_gamemaster: function() {
			var game = Games.findOne({    	
				owner: Meteor.userId()
			}); 
			if (game != undefined) {
				return true;
			} else {
				return false;
			}
		},

		has_game_as_player: function() {
			var facebookId = getUserFacebookId();
			var games = Meteor.apply('findPlayerGames', [facebookId], {returnStubValue: true});

			if (games.players != undefined) {
				return "<h1>Your games as player:</h1>";
			} else {
				return "";
			}
		},

		/*
			Return name for use in buttons
		*/
    	username: function () {
    		return getUserName();
    	},


		getImageUser: function (userId) {
		    var user= Meteor.users.findOne(userId);
		    if (user.profile) {
				return user.profile.picture; 
    		} else {
        		return "";
    		}
		}

	});

	function focusInputField(field) {
		field.focus();
		field.select();
	}
}  



getUserName = function () {
	if (Meteor.user() != undefined) {
	   return Meteor.user().username || Meteor.user().profile.name;
	} else {
		return "";
	}
}

/*
// This is the right way to do it, but it fires too early
getUserFacebookId = function() {
	var userId = Session.get('userFacebookId');
	console.log("userId " + userId);
	if ((userId != null) && (userId != undefined)) {
		return userId;
	} else {
		userId = Meteor.apply('getUserFacebook', [], {returnStubValue: true});
		console.log("USER " + userId);
		Session.set('userFacebookId', userId);
		return userId;
	}	
}
*/

getUserFacebookId = function() {
	var userId = Session.get('userFacebookId');
	if (userId != null) {
		return userId;
	} else {
		Meteor.call('getUserData', function(err, data) {
			var userId = JSON.parse(JSON.stringify(data, undefined, 4)).id;
			Session.set('userFacebookId', userId);
			return userId;
		});
	}	
}



