/*
 Note: This code is based on the question here: https://stackoverflow.com/questions/34950088/fetching-facebook-friends-list-with-meteor
*/


// first, remove configuration entry in case service is already configured
/*
Accounts.loginServiceConfiguration.remove({
	service: "facebook"
});

Accounts.loginServiceConfiguration.insert({
	service: "facebook",
	appId: "188053924897770",
	secret: "f0b4c358fc87de375dbc9c07eb96ef84"
});
*/


function Facebook(accessToken) {
	this.fb = Meteor.npmRequire('fbgraph');
	this.accessToken = accessToken;
	this.fb.setAccessToken(this.accessToken);
	this.options = {
		timeout: 3000,
		pool: {maxSockets: Infinity},
		headers: {connection: "keep-alive"}
	}    
	this.fb.setOptions(this.options);
}

Facebook.prototype.query = function(query, method) {
	var self = this;
	var method = (typeof method === 'undefined') ? 'get' : method;
	var data = Meteor.sync(function(done) {
		self.fb[method](query, function(err, res) {
			done(null, res);
		});
	});
	return data.result;
}

Facebook.prototype.getUserData = function() {
	return this.query('me');
}

Facebook.prototype.getFriendsData = function() {
	return this.query('/me/friends');
}

Meteor.methods({
	getUserData: function() {
		return new Facebook(Meteor.user().services.facebook.accessToken).getUserData();
	},

	getFriendsData: function() {
		return new Facebook(Meteor.user().services.facebook.accessToken).getFriendsData();
	}
});

Meteor.methods({
	getUserFacebook(dummy) {
		var data = new Facebook(Meteor.user().services.facebook.accessToken).getUserData();
		console.log("data");
		console.log(data);
		var userId = JSON.parse(JSON.stringify(data, undefined, 4)).id;
		console.log(userId);
		return userId;
}
});

Meteor.publish("getUserData", function () {
	return Meteor.users.find({_id: this.userId});
});

Meteor.publish("getFriendsData", function(){
	return Meteor.users.find({_id: this.userId});
});


Accounts.onCreateUser(function(options, user) {
    if (options.profile) {
        options.profile.picture = "http://graph.facebook.com/" + user.services.facebook.id + "/picture/?type=square";
        user.profile = options.profile;
    }
    return user;
});
